/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "clock.h"

unsigned char ss	= 0; //Variable fr Sekunden
unsigned char mm	= 0; //Variable fr Minuten
unsigned char hh	= 0; //Variable fr Stunden

#if USE_CLOCK

//############################################################################
// Diese Routine addiert 1 Sekunde wenn Timer Interrupt ausgelst wird 
SIGNAL (SIG_OVERFLOW1)
//############################################################################
{	TCNT1 = 65535 - (SYSCLK / 1024);
	ss++;//Addiere +1
	if(ss==60) {ss=0; mm++; if(mm==60) {mm=0; hh++; if(hh==24) {hh=0;}}}
}

//############################################################################
//Diese Routine startet und inizialisiert den Timer
void Start_Clock (void)
//############################################################################
{	timer_enable_int(_BV(TOIE1));				//Interrupt for the Clock enable
	TCCR1B |= (1<<CS10 | 0<<CS11 | 1<<CS12); //Setzen des Prescaler auf 1024 
	return;
}
#endif //#if USE_CLOCK

